// Copyright: (c) 2020-2021, VTK Gent vzw
// GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)

@import 'animations';

// Extend body and app to full height
body {
  height: 100%;
}

#__nuxt {
  height: 100%;
}

// Global Vuetify styling overrides
// All overrides of Vuetify style classes should be in this file
.container {
  max-width: $max-content-width !important;
}

.v-application {
  background-color: $background !important;
  font-family: $body-font-family, sans-serif !important;

  .title {
    // To pin point specific classes of some components
    font-family: $title-font, sans-serif !important;
  }
}

.v-window__container {
  background-color: $background;
}

.v-slide-group__next {
  background-color: $background;
}

// Studium specific styling
.studium-button {
  font-size: 16px !important;
  font-weight: 500;
  border-radius: $border-radius !important;

  &.v-tab {
    &::before {
      border-top-left-radius: $border-radius !important;
      border-top-right-radius: $border-radius !important;
    }
  }
}

.studium-title {
  color: $primary;
  font-size: 2rem;

  @media #{map-get($display-breakpoints, 'md-and-down')} {
    font-size: 1.5rem;
  }

  @media #{map-get($display-breakpoints, 'xs-only')} {
    font-size: 1.4rem;
  }

  &--larger {
    @extend .studium-title;
    font-weight: 500;

    font-size: 2.2rem;

    @media #{map-get($display-breakpoints, 'md-and-down')} {
      font-size: 2rem;
    }

    @media #{map-get($display-breakpoints, 'xs-only')} {
      font-size: 1.7rem;
    }
  }
}

.studium-subtitle {
  font-size: 1.2rem;
  color: $secondary;

  @media #{map-get($display-breakpoints, 'xs-only')} {
    font-size: 1rem;
  }
}

.studium-input {
  border-radius: $border-radius !important;

  .v-progress-linear {
    margin-left: 8px;
    margin-top: 6px;
    width: calc(100% - 16px);
  }
}

.studium-alert {
  border-radius: $border-radius !important;
  padding-top: 16px;
  padding-bottom: 16px;
}

.studium-card {
  background-color: $card-background !important;
  border-radius: $border-radius !important;
  height: 100%;
}

.studium-pagination {
  .v_pagination {
    background-color: transparent !important;
  }
  .v-pagination__navigation,
  .v-pagination__navigation--disabled,
  .v-pagination__item {
    box-shadow: none !important;
    background-color: transparent !important;
    color: $secondary-light !important;
    transition: none !important;

    &:focus {
      outline: none !important;
    }
  }

  .v-pagination__item--active {
    box-shadow: none !important;
    background-color: transparent !important;
    color: black !important;
    font-size: 18px !important;
  }
}

.studium-chip {
  &.v-chip.v-size--default {
    font-size: 16px;
    height: 22px;
  }

  // Colors are identical to the input fields color
  color: rgba(0, 0, 0, 0.6) !important;
  border-color: rgba(0, 0, 0, 0.38) !important;

  &--active {
    color: $primary !important;
    border-color: $primary !important;
  }
}

.studium-avatar {
  &.v-avatar {
    min-width: 44px !important;
    width: 44px !important;
    height: 44px !important;
  }
}

.studium-navbar {
  .v-toolbar__content {
    padding: 0 !important;
    border-bottom: 1px solid $secondary-background;
  }

  &-link {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100%;
    font-size: 1.25rem;
    font-weight: normal;
    padding-left: 20px;
    padding-right: 20px;
    text-decoration: none;
    border-bottom: 3px solid transparent;

    &:hover {
      color: $primary !important;
    }

    &--active {
      border-bottom: 3px solid $primary;
      color: $primary !important;
    }
  }
}

.studium-clickable-text {
  color: $secondary !important;
  transition: color $secondary-transition;

  .v-icon {
    color: $secondary;
  }

  &:hover {
    cursor: pointer;
    color: $primary !important;

    .v-icon {
      color: $primary;
    }
  }
}

.studium-footer {
  &.v-footer {
    border-top: 1px solid $secondary-background;
    background-color: #fbfbfd;
    padding: 0px !important;
  }
}

.studium-tabs {
  border-bottom: 1px solid $secondary-background;

  .v-tab:not(.v-tab--active) {
    color: $secondary !important;
  }
}

.studium-tab {
  padding-left: 0px;
  padding-right: 0px;
  padding-top: 0px;
  margin-left: 0px;
  margin-right: 0px;
  width: 100%;
}

// Src: https://justmarkup.com/articles/2015-07-31-dealing-with-long-words-in-css/
// This solution will show hyphens for every browser supporting it and will break lines in every other browser – perfect.
.studium-hyphenate {
  overflow-wrap: break-word;
  word-wrap: break-word;
  word-break: break-word;
  -webkit-hyphens: auto;
  -ms-hyphens: auto;
  -moz-hyphens: auto;
  hyphens: auto;
}

.studium-center {
  display: flex;
  justify-content: center;
  align-items: center;
}

.d-hidden {
  visibility: hidden;
}

h1 {
  color: $primary;
  font-weight: normal;
  font-size: 26px;
  border-bottom: hidden;
  box-sizing: border-box;
  margin-top: 0.33em;
  margin-bottom: 0.33em;
}

h2 {
  color: $primary;
  font-weight: normal;
  font-size: 20px;
  border-bottom: hidden;
  box-sizing: border-box;
  margin-top: 0.2em;
  margin-bottom: 0.2em;
}

h3,
h4,
h5,
h6,
p,
[data-type='Paragraph'] {
  font-weight: normal;
  font-size: 16px;
}

a {
  color: inherit !important;
  text-decoration: none !important;
}

// Default table styling
table {
  border-collapse: collapse;
  table-layout: fixed;
  margin: 0;
  overflow: hidden;
  margin-bottom: 16px;

  td,
  th {
    min-width: 1em;
    border: 2px solid $secondary-background;
    vertical-align: middle;
    box-sizing: border-box;
    position: relative;
    padding: 8px;

    p {
      margin: 0 !important;
    }
  }

  th {
    font-weight: bold;
    text-align: left;
    background-color: $secondary-background;
  }
}
